# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Resource types**

* [`dsc_xarchive`](#dsc_xarchive): The DSC xArchive resource type. Automatically generated from version 9.1.0
* [`dsc_xdscwebservice`](#dsc_xdscwebservice): The DSC xDSCWebService resource type. Automatically generated from version 9.1.0
* [`dsc_xenvironment`](#dsc_xenvironment): The DSC xEnvironment resource type. Automatically generated from version 9.1.0
* [`dsc_xfileupload`](#dsc_xfileupload): The DSC  resource type. Automatically generated from version 9.1.0
* [`dsc_xgroup`](#dsc_xgroup): The DSC xGroup resource type. Automatically generated from version 9.1.0
* [`dsc_xgroupset`](#dsc_xgroupset): The DSC  resource type. Automatically generated from version 9.1.0
* [`dsc_xmsipackage`](#dsc_xmsipackage): The DSC xMsiPackage resource type. Automatically generated from version 9.1.0
* [`dsc_xpackage`](#dsc_xpackage): The DSC xPackage resource type. Automatically generated from version 9.1.0
* [`dsc_xprocessset`](#dsc_xprocessset): The DSC  resource type. Automatically generated from version 9.1.0
* [`dsc_xpsendpoint`](#dsc_xpsendpoint): The DSC xPSEndpoint resource type. Automatically generated from version 9.1.0
* [`dsc_xregistry`](#dsc_xregistry): The DSC xRegistry resource type. Automatically generated from version 9.1.0
* [`dsc_xremotefile`](#dsc_xremotefile): The DSC xRemoteFile resource type. Automatically generated from version 9.1.0
* [`dsc_xscript`](#dsc_xscript): The DSC xScript resource type. Automatically generated from version 9.1.0
* [`dsc_xservice`](#dsc_xservice): The DSC xService resource type. Automatically generated from version 9.1.0
* [`dsc_xserviceset`](#dsc_xserviceset): The DSC  resource type. Automatically generated from version 9.1.0
* [`dsc_xuser`](#dsc_xuser): The DSC xUser resource type. Automatically generated from version 9.1.0
* [`dsc_xwindowsfeature`](#dsc_xwindowsfeature): The DSC xWindowsFeature resource type. Automatically generated from version 9.1.0
* [`dsc_xwindowsfeatureset`](#dsc_xwindowsfeatureset): The DSC  resource type. Automatically generated from version 9.1.0
* [`dsc_xwindowsoptionalfeature`](#dsc_xwindowsoptionalfeature): The DSC xWindowsOptionalFeature resource type. Automatically generated from version 9.1.0
* [`dsc_xwindowsoptionalfeatureset`](#dsc_xwindowsoptionalfeatureset): The DSC  resource type. Automatically generated from version 9.1.0
* [`dsc_xwindowspackagecab`](#dsc_xwindowspackagecab): The DSC xWindowsPackageCab resource type. Automatically generated from version 9.1.0
* [`dsc_xwindowsprocess`](#dsc_xwindowsprocess): The DSC xWindowsProcess resource type. Automatically generated from version 9.1.0

## Resource types

### dsc_xarchive

The DSC xArchive resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xarchive` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_validate`

Data type: `Optional[Boolean]`

%q{
        Specifies whether or not to validate that a file at the destination with the same name as a file in the archive actually matches that corresponding file in the archive by the specified checksum method. If the file does not match and Ensure is specified as Present and Force is not specified, the resource will throw an error that the file at the desintation cannot be overwritten. If the file does not match and Ensure is specified as Present and Force is specified, the file at the desintation will be overwritten. If the file does not match and Ensure is specified as Absent, the file at the desintation will not be removed. The default value is false.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Specifies whether or not the expanded content of the archive file at the specified path should exist at the specified destination. To update the specified destination to have the expanded content of the archive file at the specified path, specify this property as Present. To remove the expanded content of the archive file at the specified path from the specified destination, specify this property as Absent. The default value is Present.
      }

##### `dsc_destination`

Data type: `Optional[String]`

%q{
        The path where the specified archive file should be expanded to or removed from.
      }

##### `dsc_force`

Data type: `Optional[Boolean]`

%q{
        Specifies whether or not any existing files or directories at the destination with the same name as a file or directory in the archive should be overwritten to match the file or directory in the archive. When this property is false, an error will be thrown if an item at the destination needs to be overwritten. The default value is false.
      }

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        The credential of a user account with permissions to access the specified archive path and destination if needed.
      }

##### `dsc_path`

Data type: `Optional[String]`

%q{
        The path to the archive file that should be expanded to or removed from the specified destination.
      }

##### `dsc_checksum`

Data type: `Optional[Enum['sha-1', 'sha-256', 'sha-512', 'createddate', 'modifieddate']]`

%q{
        The Checksum method to use to validate whether or not a file at the destination with the same name as a file in the archive actually matches that corresponding file in the archive. An invalid argument exception will be thrown if Checksum is specified while Validate is specified as false. ModifiedDate will check that the LastWriteTime property of the file at the destination matches the LastWriteTime property of the file in the archive. CreatedDate will check that the CreationTime property of the file at the destination matches the CreationTime property of the file in the archive. SHA-1, SHA-256, and SHA-512 will check that the hash of the file at the destination by the specified SHA method matches the hash of the file in the archive by the specified SHA method. The default value is ModifiedDate.
      }

#### Parameters

The following parameters are available in the `dsc_xarchive` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xdscwebservice

The DSC xDSCWebService resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xdscwebservice` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_modulepath`

Data type: `Optional[String]`

%q{
        The location on the disk where the Modules are stored.
      }

##### `dsc_registrationkeypath`

Data type: `Optional[String]`

%q{
        The location on the disk where the RegistrationKeys file is stored.
      }

##### `dsc_sqlprovider`

Data type: `Optional[Boolean]`

%q{
        Enable DSC Pull Server to use SQL server as the backend database.
      }

##### `dsc_port`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        The port number of the DSC Pull Server IIS Endpoint.
      }

##### `dsc_applicationpoolname`

Data type: `Optional[String]`

%q{
        The IIS ApplicationPool to use for the Pull Server. If not specified a pool with name 'PSWS' will be created.
      }

##### `dsc_configurefirewall`

Data type: `Optional[Boolean]`

%q{
        Enable incomming firewall exceptions for the configured DSC Pull Server port. Defaults to true.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_configurationpath`

Data type: `Optional[String]`

%q{
        The location on the disk where the Configuration is stored.
      }

##### `dsc_certificatetemplatename`

Data type: `Optional[String]`

%q{
        The certificate Template Name of the Certificate in CERT:\LocalMachine\MY\ for Pull Server.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Specifies if the DSC Web Service should be installed.
      }

##### `dsc_sqlconnectionstring`

Data type: `Optional[String]`

%q{
        The connection string to use to connect to the SQL server backend database. Required if SqlProvider is true.
      }

##### `dsc_certificatesubject`

Data type: `Optional[String]`

%q{
        The subject of the Certificate in CERT:\LocalMachine\MY\ for Pull Server.
      }

##### `dsc_physicalpath`

Data type: `Optional[String]`

%q{
        The physical path for the IIS Endpoint on the machine (usually under inetpub).
      }

##### `dsc_certificatethumbprint`

Data type: `Optional[String]`

%q{
        The thumbprint of the Certificate in CERT:\LocalMachine\MY\ for Pull Server.
      }

##### `dsc_state`

Data type: `Optional[Enum['started', 'stopped']]`

%q{
        Specifies the state of the DSC Web Service.
      }

##### `dsc_disablesecuritybestpractices`

Data type: `Optional[Array[Enum['securetlsprotocols']]]`

%q{
        A list of exceptions to the security best practices to apply.
      }

##### `dsc_databasepath`

Data type: `Optional[String]`

%q{
        The location on the disk where the database is stored.
      }

##### `dsc_endpointname`

Data type: `Optional[String]`

%q{
        Prefix of the WCF SVC file.
      }

##### `dsc_enable32bitapponwin64`

Data type: `Optional[Boolean]`

%q{
        Enable the DSC Pull Server to run in a 32-bit process on a 64-bit operating system.
      }

##### `dsc_acceptselfsignedcertificates`

Data type: `Optional[Boolean]`

%q{
        Specifies is self-signed certs will be accepted for client authentication.
      }

#### Parameters

The following parameters are available in the `dsc_xdscwebservice` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_usesecuritybestpractices`

namevar

Data type: `Boolean`

%q{
        This property will ensure that the Pull Server is created with the most secure practices.
      }

### dsc_xenvironment

The DSC xEnvironment resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xenvironment` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Specifies if the environment variable should exist.
      }

##### `dsc_value`

Data type: `Optional[String]`

%q{
        The desired value for the environment variable.
      }

##### `dsc_name`

Data type: `Optional[String]`

%q{
        The name of the environment variable for which you want to ensure a specific state.
      }

##### `dsc_target`

Data type: `Optional[Array[Enum['process', 'machine']]]`

%q{
        Indicates the target where the environment variable should be set.
      }

##### `dsc_path`

Data type: `Optional[Boolean]`

%q{
        Indicates whether or not the environment variable is the Path variable.
      }

#### Parameters

The following parameters are available in the `dsc_xenvironment` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xfileupload

The DSC  resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xfileupload` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_certificatethumbprint`

Data type: `Optional[String]`

%q{}

#### Parameters

The following parameters are available in the `dsc_xfileupload` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_destinationpath`

namevar

Data type: `String`

%q{}

##### `dsc_sourcepath`

namevar

Data type: `String`

%q{}

### dsc_xgroup

The DSC xGroup resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xgroup` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        A credential to resolve non-local group members.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Indicates if the group should exist or not.
      }

##### `dsc_memberstoinclude`

Data type: `Optional[Array[String]]`

%q{
        The members the group should include.
      }

##### `dsc_description`

Data type: `Optional[String]`

%q{
        The description the group should have.
      }

##### `dsc_groupname`

Data type: `Optional[String]`

%q{
        The name of the group to create, modify, or remove.
      }

##### `dsc_memberstoexclude`

Data type: `Optional[Array[String]]`

%q{
        The members the group should exclude.
      }

##### `dsc_members`

Data type: `Optional[Array[String]]`

%q{
        The members the group should have.
      }

#### Parameters

The following parameters are available in the `dsc_xgroup` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xgroupset

The DSC  resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xgroupset` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[String]`

%q{}

##### `dsc_memberstoinclude`

Data type: `Optional[Array[String]]`

%q{}

##### `dsc_memberstoexclude`

Data type: `Optional[Array[String]]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

#### Parameters

The following parameters are available in the `dsc_xgroupset` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_groupname`

namevar

Data type: `Array[String]`

%q{}

### dsc_xmsipackage

The DSC xMsiPackage resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xmsipackage` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_ignorereboot`

Data type: `Optional[Boolean]`

%q{
        Ignore a pending reboot if requested by package installation.
      }

##### `dsc_signerthumbprint`

Data type: `Optional[String]`

%q{
        The certificate thumbprint that should match the signer certificate of the digital signature of the MSI file.
      }

##### `dsc_runascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        The credential of a user account under which to run the installation or uninstallation of the MSI package.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        The credential of a user account to be used to mount a UNC path if needed.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Specifies whether or not the MSI file should be installed or uninstalled.
      }

##### `dsc_arguments`

Data type: `Optional[String]`

%q{
        The arguments to be passed to the MSI package during installation or uninstallation.
      }

##### `dsc_hashalgorithm`

Data type: `Optional[Enum['sha1', 'sha256', 'sha384', 'sha512', 'md5', 'ripemd160']]`

%q{
        The algorithm used to generate the given hash value.
      }

##### `dsc_filehash`

Data type: `Optional[String]`

%q{
        The expected hash value of the MSI file at the given path.
      }

##### `dsc_servercertificatevalidationcallback`

Data type: `Optional[String]`

%q{
        PowerShell code that should be used to validate SSL certificates for paths using HTTPS.
      }

##### `dsc_productid`

Data type: `Optional[String]`

%q{
        The identifying number used to find the package, usually a GUID.
      }

##### `dsc_signersubject`

Data type: `Optional[String]`

%q{
        The subject that should match the signer certificate of the digital signature of the MSI file.
      }

##### `dsc_logpath`

Data type: `Optional[String]`

%q{
        The path to the log file to log the output from the MSI execution.
      }

#### Parameters

The following parameters are available in the `dsc_xmsipackage` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_path`

namevar

Data type: `String`

%q{
        The path to the MSI file that should be installed or uninstalled.
      }

### dsc_xpackage

The DSC xPackage resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xpackage` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_ignorereboot`

Data type: `Optional[Boolean]`

%q{
        Ignore a pending reboot if requested by package installation.
      }

##### `dsc_createcheckregvalue`

Data type: `Optional[Boolean]`

%q{}

##### `dsc_servercertificatevalidationcallback`

Data type: `Optional[String]`

%q{}

##### `dsc_name`

Data type: `Optional[String]`

%q{}

##### `dsc_signerthumbprint`

Data type: `Optional[String]`

%q{}

##### `dsc_runascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_installedcheckregvaluename`

Data type: `Optional[String]`

%q{}

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{}

##### `dsc_arguments`

Data type: `Optional[String]`

%q{}

##### `dsc_installedcheckregkey`

Data type: `Optional[String]`

%q{}

##### `dsc_filehash`

Data type: `Optional[String]`

%q{}

##### `dsc_hashalgorithm`

Data type: `Optional[Enum['sha1', 'sha256', 'sha384', 'sha512', 'md5', 'ripemd160']]`

%q{}

##### `dsc_returncode`

Data type: `Optional[Array[Integer[0, 4294967295]]]`

%q{}

##### `dsc_installedcheckreghive`

Data type: `Optional[Enum['localmachine', 'currentuser']]`

%q{}

##### `dsc_productid`

Data type: `Optional[String]`

%q{}

##### `dsc_installedcheckregvaluedata`

Data type: `Optional[String]`

%q{}

##### `dsc_signersubject`

Data type: `Optional[String]`

%q{}

##### `dsc_logpath`

Data type: `Optional[String]`

%q{}

#### Parameters

The following parameters are available in the `dsc_xpackage` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_path`

namevar

Data type: `String`

%q{}

### dsc_xprocessset

The DSC  resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xprocessset` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[String]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_standardoutputpath`

Data type: `Optional[String]`

%q{}

##### `dsc_standarderrorpath`

Data type: `Optional[String]`

%q{}

##### `dsc_standardinputpath`

Data type: `Optional[String]`

%q{}

##### `dsc_workingdirectory`

Data type: `Optional[String]`

%q{}

#### Parameters

The following parameters are available in the `dsc_xprocessset` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_path`

namevar

Data type: `Array[String]`

%q{}

### dsc_xpsendpoint

The DSC xPSEndpoint resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xpsendpoint` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_accessmode`

Data type: `Optional[Enum['local', 'remote', 'disabled']]`

%q{
        Enables and disables the session configuration and determines whether it can be used for remote or local sessions on the computer. The default value is 'Remote'.
      }

##### `dsc_name`

Data type: `Optional[String]`

%q{
        Specifies the name of the session configuration.
      }

##### `dsc_securitydescriptorsddl`

Data type: `Optional[String]`

%q{
        Specifies the Security Descriptor Definition Language (SDDL) string for the configuration.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Indicates if the session configuration should exist. The default value is 'Present'.
      }

##### `dsc_startupscript`

Data type: `Optional[String]`

%q{
        Specifies the startup script for the configuration. Enter the fully qualified path of a Windows PowerShell script.
      }

##### `dsc_runascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        Specifies the credential for commands of this session configuration.
      }

#### Parameters

The following parameters are available in the `dsc_xpsendpoint` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xregistry

The DSC xRegistry resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xregistry` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_hex`

Data type: `Optional[Boolean]`

%q{
        Specifies whether or not the specified DWord or QWord registry key data is provided in a hexadecimal format. Not valid for types other than DWord and QWord. The default value is $false.
      }

##### `dsc_valuename`

Data type: `Optional[String]`

%q{
        The name of the registry value. To add or remove a registry key, specify this property as an empty string without specifying ValueType or ValueData. To modify or remove the default value of a registry key, specify this property as an empty string while also specifying ValueType or ValueData.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_key`

Data type: `Optional[String]`

%q{
        The path of the registry key to add, modify, or remove. This path must include the registry hive/drive.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Specifies whether or not the registry key or value should exist. To add or modify a registry key or value, set this property to Present. To remove a registry key or value, set the property to Absent.
      }

##### `dsc_valuetype`

Data type: `Optional[Enum['string', 'binary', 'dword', 'qword', 'multistring', 'expandstring']]`

%q{
        The type the specified registry key value should have.
      }

##### `dsc_force`

Data type: `Optional[Boolean]`

%q{
        Specifies whether or not to overwrite the specified registry key value if it already has a value or whether or not to delete a registry key that has subkeys. The default value is $false.
      }

##### `dsc_valuedata`

Data type: `Optional[Array[String]]`

%q{
        The data the specified registry key value should have as a string or an array of strings (MultiString only).
      }

#### Parameters

The following parameters are available in the `dsc_xregistry` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xremotefile

The DSC xRemoteFile resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xremotefile` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_proxycredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        Specifies a user account that has permission to use the proxy server that is specified by the Proxy parameter.
      }

##### `dsc_useragent`

Data type: `Optional[String]`

%q{
        User agent for the web request.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_timeoutsec`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        Specifies how long the request can be pending before it times out.
      }

##### `dsc_checksum`

Data type: `Optional[String]`

%q{
        Specifies the checksum value to compare against the downloaded file
      }

##### `dsc_matchsource`

Data type: `Optional[Boolean]`

%q{
        A boolean value to indicate whether the remote file should be re-downloaded if the file in the DestinationPath was modified locally. The default value is true.
      }

##### `dsc_headers`

Data type: `Array[Struct[{
              key => Optional[String],
              value => Optional[String],
            }]]`

%q{
        Headers of the web request.
      }

##### `dsc_destinationpath`

Data type: `Optional[String]`

%q{
        Path under which downloaded or copied file should be accessible after operation.
      }

##### `dsc_checksumtype`

Data type: `Optional[Enum['none', 'sha1', 'sha256', 'sha384', 'sha512', 'mactripledes', 'md5', 'ripemd160']]`

%q{
        Specifies the checksum type to verify the downloaded file
      }

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        Specifies a user account that has permission to send the request.
      }

##### `dsc_proxy`

Data type: `Optional[String]`

%q{
        Uses a proxy server for the request, rather than connecting directly to the Internet resource. Should be the URI of a network proxy server (e.g 'http://10.20.30.1').
      }

#### Parameters

The following parameters are available in the `dsc_xremotefile` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_uri`

namevar

Data type: `String`

%q{
        Uri of a file which should be copied or downloaded. This parameter supports HTTP and HTTPS values.
      }

### dsc_xscript

The DSC xScript resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xscript` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        The credential of the user account to run the script under if needed.
      }

##### `dsc_setscript`

Data type: `Optional[String]`

%q{
        A string that can be used to create a PowerShell script block that sets the resource to the desired state.
      }

##### `dsc_getscript`

Data type: `Optional[String]`

%q{
        A string that can be used to create a PowerShell script block that retrieves the current state of the resource.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_testscript`

Data type: `Optional[String]`

%q{
        A string that can be used to create a PowerShell script block that validates whether or not the resource is in the desired state.
      }

#### Parameters

The following parameters are available in the `dsc_xscript` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xservice

The DSC xService resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xservice` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_description`

Data type: `Optional[String]`

%q{
        The description of the service.
      }

##### `dsc_terminatetimeout`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        The time to wait for the service to stop in milliseconds. Defaults to 30000.
      }

##### `dsc_displayname`

Data type: `Optional[String]`

%q{
        The display name of the service.
      }

##### `dsc_startuptimeout`

Data type: `Optional[Integer[0, 4294967295]]`

%q{
        The time to wait for the service to start in milliseconds. Defaults to 30000.
      }

##### `dsc_groupmanagedserviceaccount`

Data type: `Optional[String]`

%q{
        The Group Managed Service Account to run the service under.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_name`

Data type: `Optional[String]`

%q{
        Indicates the service name. Note that sometimes this is different from the display name. You can get a list of the services and their current state with the Get-Service cmdlet.
      }

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        The credential to run the service under.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Ensures that the service is present or absent. Defaults to Present.
      }

##### `dsc_builtinaccount`

Data type: `Optional[Enum['localsystem', 'localservice', 'networkservice']]`

%q{
        Indicates the sign-in account to use for the service.
      }

##### `dsc_startuptype`

Data type: `Optional[Enum['automatic', 'manual', 'disabled']]`

%q{
        Indicates the startup type for the service.
      }

##### `dsc_state`

Data type: `Optional[Enum['running', 'stopped', 'ignore']]`

%q{
        Indicates the state you want to ensure for the service. Defaults to Running.
      }

##### `dsc_desktopinteract`

Data type: `Optional[Boolean]`

%q{
        The service can create or communicate with a window on the desktop. Must be false for services not running as LocalSystem. Defaults to False.
      }

##### `dsc_path`

Data type: `Optional[String]`

%q{
        The path to the service executable file.
      }

##### `dsc_dependencies`

Data type: `Optional[Array[String]]`

%q{
        An array of strings indicating the names of the dependencies of the service.
      }

#### Parameters

The following parameters are available in the `dsc_xservice` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xserviceset

The DSC  resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xserviceset` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[String]`

%q{}

##### `dsc_startuptype`

Data type: `Optional[String]`

%q{}

##### `dsc_builtinaccount`

Data type: `Optional[String]`

%q{}

##### `dsc_state`

Data type: `Optional[String]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

#### Parameters

The following parameters are available in the `dsc_xserviceset` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_name`

namevar

Data type: `Array[String]`

%q{}

### dsc_xuser

The DSC xUser resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xuser` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_password`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        The password for the user
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        An enumerated value that describes if the user is expected to exist on the machine
      }

##### `dsc_fullname`

Data type: `Optional[String]`

%q{
        The display name of the user
      }

##### `dsc_disabled`

Data type: `Optional[Boolean]`

%q{
        Value used to disable/enable a user account
      }

##### `dsc_username`

Data type: `Optional[String]`

%q{
        The name of the User to Create/Modify/Delete
      }

##### `dsc_passwordneverexpires`

Data type: `Optional[Boolean]`

%q{
        Value used to set whether a user's password expires or not
      }

##### `dsc_description`

Data type: `Optional[String]`

%q{
        A description for the user
      }

##### `dsc_passwordchangerequired`

Data type: `Optional[Boolean]`

%q{
        Value used to require a user to change their password
      }

##### `dsc_passwordchangenotallowed`

Data type: `Optional[Boolean]`

%q{
        Value used to set whether a user can/cannot change their password
      }

#### Parameters

The following parameters are available in the `dsc_xuser` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xwindowsfeature

The DSC xWindowsFeature resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xwindowsfeature` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Specifies whether the role or feature should be installed or uninstalled. To install the feature, set this property to Present. To uninstall the feature, set the property to Absent.
      }

##### `dsc_logpath`

Data type: `Optional[String]`

%q{
        The path to the log file to log this operation.
      }

##### `dsc_includeallsubfeature`

Data type: `Optional[Boolean]`

%q{
        Specifies whether the subfeatures of the main feature should also be installed.
      }

##### `dsc_name`

Data type: `Optional[String]`

%q{
        The name of the role or feature to install or uninstall.
      }

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        A credential, if needed, to install or uninstall the role or feature.
      }

#### Parameters

The following parameters are available in the `dsc_xwindowsfeature` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xwindowsfeatureset

The DSC  resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xwindowsfeatureset` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[String]`

%q{}

##### `dsc_source`

Data type: `Optional[String]`

%q{}

##### `dsc_includeallsubfeature`

Data type: `Optional[Boolean]`

%q{}

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_logpath`

Data type: `Optional[String]`

%q{}

#### Parameters

The following parameters are available in the `dsc_xwindowsfeatureset` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_name`

namevar

Data type: `Array[String]`

%q{}

### dsc_xwindowsoptionalfeature

The DSC xWindowsOptionalFeature resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xwindowsoptionalfeature` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_removefilesondisable`

Data type: `Optional[Boolean]`

%q{
        Specifies that all files associated with the feature should be removed if the feature is being disabled.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Specifies whether the feature should be enabled or disabled. To enable the feature, set this property to Present. To disable the feature, set the property to Absent.
      }

##### `dsc_logpath`

Data type: `Optional[String]`

%q{
        The path to the log file to log this operation.
      }

##### `dsc_nowindowsupdatecheck`

Data type: `Optional[Boolean]`

%q{
        Specifies whether or not DISM contacts Windows Update (WU) when searching for the source files to enable the feature. If $true, DISM will not contact WU.
      }

##### `dsc_name`

Data type: `Optional[String]`

%q{
        The name of the feature to enable or disable.
      }

##### `dsc_loglevel`

Data type: `Optional[Enum['errorsonly', 'errorsandwarning', 'errorsandwarningandinformation']]`

%q{
        The maximum output level to show in the log. Accepted values are: ErrorsOnly (only errors are logged), ErrorsAndWarning (errors and warnings are logged), and ErrorsAndWarningAndInformation (errors, warnings, and debug information are logged).
      }

#### Parameters

The following parameters are available in the `dsc_xwindowsoptionalfeature` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### dsc_xwindowsoptionalfeatureset

The DSC  resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xwindowsoptionalfeatureset` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_removefilesondisable`

Data type: `Optional[Boolean]`

%q{}

##### `dsc_nowindowsupdatecheck`

Data type: `Optional[Boolean]`

%q{}

##### `dsc_logpath`

Data type: `Optional[String]`

%q{}

##### `dsc_loglevel`

Data type: `Optional[String]`

%q{}

#### Parameters

The following parameters are available in the `dsc_xwindowsoptionalfeatureset` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_name`

namevar

Data type: `Array[String]`

%q{}

##### `dsc_ensure`

namevar

Data type: `String`

%q{}

### dsc_xwindowspackagecab

The DSC xWindowsPackageCab resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xwindowspackagecab` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_logpath`

Data type: `Optional[String]`

%q{
        The path to a file to log the operation to.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_name`

Data type: `Optional[String]`

%q{
        The name of the package to install or uninstall.
      }

#### Parameters

The following parameters are available in the `dsc_xwindowspackagecab` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### `dsc_sourcepath`

namevar

Data type: `String`

%q{
        The path to the cab file to install or uninstall the package from.
      }

##### `dsc_ensure`

namevar

Data type: `Enum['present', 'absent']`

%q{
        Specifies whether the package should be installed or uninstalled. To install the package, set this property to Present. To uninstall the package, set the property to Absent.
      }

### dsc_xwindowsprocess

The DSC xWindowsProcess resource type.
Automatically generated from version 9.1.0

#### Properties

The following properties are available in the `dsc_xwindowsprocess` type.

##### `ensure`

Data type: `Enum[present, absent]`

Whether this resource should be present or absent on the target system.

Default value: present

##### `dsc_workingdirectory`

Data type: `Optional[String]`

%q{
        The directory to run the processes under.
      }

##### `dsc_standardinputpath`

Data type: `Optional[String]`

%q{
        The path to receive standard input from.
      }

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{}

##### `dsc_standarderrorpath`

Data type: `Optional[String]`

%q{
        The path to write the standard error stream to.
      }

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

%q{
        The credential to run the process under.
      }

##### `dsc_ensure`

Data type: `Optional[Enum['present', 'absent']]`

%q{
        Indicates whether the process is present (running) or absent (not running).
      }

##### `dsc_standardoutputpath`

Data type: `Optional[String]`

%q{
        The path to write the standard output stream to.
      }

##### `dsc_arguments`

Data type: `Optional[String]`

%q{
        A string of arguments to pass to the process executable. Pass in an empty string if no arguments are needed.
      }

##### `dsc_path`

Data type: `Optional[String]`

%q{
        The full path or file name to the process executable to start or stop.
      }

#### Parameters

The following parameters are available in the `dsc_xwindowsprocess` type.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

